<?php

  session_start();

  require("inc/config.php");
  
  if(!isset($_SESSION['username'])){
  header("Location: login.php");
  exit();
  
  }

  $page_title = "Location Search";

  include("inc/header.php");
          
?>

    <link href="https://use.fontawesome.com/releases/v5.0.6/css/all.css" rel="stylesheet">
    <style type="text/css">
      #customer-map {
        width: 100%;
        height: 400px;
        margin-bottom: 12px;
      }
      .dropdown.dropdown-lg .dropdown-menu {
          margin-top: -1px;
          padding: 6px 20px;
      }
      .input-group-btn .btn-group {
          display: flex !important;
      }
      .btn-group .btn {
          border-radius: 0;
          margin-left: -1px;
      }
      .btn-group .btn:last-child {
          border-top-right-radius: 4px;
          border-bottom-right-radius: 4px;
      }
      .btn-group .form-horizontal .btn[type="submit"] {
        border-top-left-radius: 4px;
        border-bottom-left-radius: 4px;
      }
      .form-horizontal .form-group {
          margin-left: 0;
          margin-right: 0;
      }
      .form-group .form-control:last-child {
          border-top-left-radius: 4px;
          border-bottom-left-radius: 4px;
      }
      
      @media screen and (min-width: 768px) {
          #adv-search {
              width: 500px;
              margin: 0 auto;
          }
          .dropdown.dropdown-lg {
              position: static !important;
          }
          .dropdown.dropdown-lg .dropdown-menu {
              min-width: 300px;
          }
      }
      
    </style>
	
	<link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap.min.css" crossorigin="anonymous">
  <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js" crossorigin="anonymous"></script>
  <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap.min.js" crossorigin="anonymous"></script>
  <script src="https://cdn.datatables.net/plug-ins/1.13.6/sorting/any-number.js" crossorigin="anonymous"></script>
  <script src="assets/date-eu.js" crossorigin="anonymous"></script>
	
    <script type="text/javascript">
	
	      $(document).ready(function(){

          $('#customer-results').DataTable(
            {
              "paging":   false,
              "search":   false,
              "info":     false,
              "columnDefs": [
                  { "type": 'any-number', "targets": 4 },
                  { "orderSequence": [ "desc" , "asc" ], "targets": 4 },
                  { "type": 'date-eu', "targets": [5, 6] }
               ]
            }
          );
          
          $('#customer-results_wrapper .row:first').hide();

      });
    
      // This example displays an address form, using the autocomplete feature
      // of the Google Places API to help users fill in the information.

      // This example requires the Places library. Include the libraries=places
      // parameter when you first load the API. For example:
      // <script src="https://maps.googleapis.com/maps/api/js?key=YOUR_API_KEY&libraries=places">

      var map, placeSearch, autocomplete, lat, lng;

      function initMap() {
        map = new google.maps.Map(document.getElementById('customer-map'), {
          center: {lat: lat, lng: lng},
          zoom: 14
        });
      }
                  
      function initAutocomplete() {
        // Create the autocomplete object, restricting the search to geographical
        // location types.
        autocomplete = new google.maps.places.Autocomplete(
            /** @type {!HTMLInputElement} */(document.getElementById('search-input')),
            {types: ['geocode']});

        // When the user selects an address from the dropdown, populate the address
        // fields in the form.
        autocomplete.addListener('place_changed', fillInAddress);
        
        <?php
          if(INSTANCE == "AU"){
        ?>
        //bias search to Victoria    
        var center = new google.maps.LatLng(-36.686043, 143.580322);
        <?php
          } elseif(INSTANCE == "NZ"){
        ?>
        //bias search to Auckland    
        var center = new google.maps.LatLng(-36.848461, 174.763336);
        <?php
          } elseif(INSTANCE == "AM"){
        ?>
        //bias search to Adelaide    
        var center = new google.maps.LatLng(-34.92866, 138.59863);
        <?php
          }
        ?>
        var circle = new google.maps.Circle({
            center: center,
            radius: 100 * 1000
        });
        autocomplete.setBounds(circle.getBounds());
        
    
      }
      
      function addMapPoint(debtor, name, sales_branch, lat, lng){
        
        //remove htmlentities from name
        var elem = document.createElement('textarea');
        elem.innerHTML = name;
        name = elem.value;
        elem = null;
        
        var infoWindow = new google.maps.InfoWindow;

        var point = new google.maps.LatLng(
            parseFloat(lat),
            parseFloat(lng)
            );

        var infowincontent = document.createElement('div');
        var strong = document.createElement('strong');
        strong.textContent = name;
        infowincontent.appendChild(strong);
        infowincontent.appendChild(document.createElement('br'));

        var text = document.createElement('a');
        text.setAttribute('href', 'customer.php?debtor=' + encodeURIComponent(debtor));
        text.innerHTML = debtor;
        infowincontent.appendChild(text);
        
        var branchcode = document.createElement('span');
        branchcode.textContent = " (" + sales_branch + ")"; 
        infowincontent.appendChild(branchcode);

        var marker = new google.maps.Marker({
          map: map,
          position: point
        });
        
        marker.addListener('click', function() {
          infoWindow.setContent(infowincontent);
          infoWindow.open(map, marker);
  
        });
        
      }

      function fillInAddress() {
        
        // Get the place details from the autocomplete object.
        var place = autocomplete.getPlace();
        
        //console.log(place);
        
        //set global vars
        lat = place.geometry.location.lat();
        lng = place.geometry.location.lng();
        
        return ;
        
        
        for (var component in componentForm) {
          document.getElementById(component).value = '';
          document.getElementById(component).disabled = false;
        }

        // Get each component of the address from the place details
        // and fill the corresponding field on the form.
        for (var i = 0; i < place.address_components.length; i++) {
          var addressType = place.address_components[i].types[0];
          if (componentForm[addressType]) {
            var val = place.address_components[i][componentForm[addressType]];
            document.getElementById(addressType).value = val;
          }
        }
      }


    $(document).ready(function(){
      
      //when search field highlighted, then ENTER key should search
      $('#search-input').keypress(function(event){
        if(event.keyCode == 13 && lat && lng){
          $('#search-button').click();
        }
      });
      
      $('.search-button').click(function() {
          
          if($('#search-input').val() && lat && lng){
          
            $('#search-input').prop('readonly', true);
            $('.search-button').prop('disabled', true);
            $('#customer-results tbody').html('');
            $('#results-div').hide();
            $('#result-summary').hide();
            
            map = null;
            initMap();
            
            if($("#filter_new").is(':checked')){
            
              var filter_new = "yes";
            
            } else {
              
              var filter_new = "";
                          
            }
          
            $.ajax({
            
                url : 'ajax.php?type=search_location', //ajax.php expects this in POST
                type : 'POST',
                data : {
                    'search-input' : $('#search-input').val(),
					'cust_cate' : $('#cust_cate').val(),
                    'distance' : $('#distance').val(),
                    'filter_new' : filter_new,
                    'rating' : $('#filter_rating').val(),
                    'lat' : lat,
                    'lng' : lng 
                },
                dataType:'json',
                success: function(data){
                  
                  $('#search-input').prop('readonly', false);
                  $('.search-button').prop('disabled', false);
                  
                  $('#result-summary').show();
                  
                  
                  //clear old results
                  $('#customer-results tbody').html('');
                  
                  $.each(data.items, function( index, row ) {
           
                    $('#customer-results tbody').append('<tr>' +
                    '<td><a href="customer.php?debtor=' + encodeURIComponent(row.debtor) + '">' + row.debtor + '</a></td>' +
                    '<td>' + row.name + '</td>' +
					'<td>' + row.sales_branch + '</td>' +
                    '<td>' + row.cust_cate + '</td>' +    
                    '<td>' + row.distance + '</td>' +
                    '<td>' + row.last_checkin + '</td>' +
                    '<td>' + row.rating + '</td>' +
                    '</tr>');
                    
                    addMapPoint(row.debtor, row.name, row.sales_branch, row.lat, row.lng, row.cust_cate);
                  
                  });

                  

                  $('#distance-result').html($('#distance').val() + 'km');
                  $('#location-result').html($('#search-input').val());
                  
                   
                  $('#results-div').fadeIn();                  


                  
                  
                  
                },
                error: function(request,error)
                {
                    alert("Request: "+JSON.stringify(request));
                }
              }); 
          
          } else {
          
            alert("Please select a location");
            return ;
            
          }
        
          
              
        });
      
      });
          
    </script>
    

    <div class="container">
    	<div class="row">
    		<div class="col-md-12">
                <div class="input-group" id="adv-search">
                    <input type="text" class="form-control" name="search-input" id="search-input" placeholder="Search location" />
                    <div class="input-group-btn">
                        <div class="btn-group" role="group">
                            <div class="dropdown dropdown-lg">
                                <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-expanded="false"><span class="caret"></span></button>
                                <div class="dropdown-menu dropdown-menu-right" role="menu">
                                    <form class="form-horizontal" role="form">
                                     <div class="form-group">
                                        <label for="filter">Filter by</label>
                                        <select class="form-control" name="cust_cate" id="cust_cate">
                                            <option value="" selected>All categories</option>
                                            <option value="RESLR">Resellers</option>
                                            <option value="OEM">OEM</option>
                                            <option value="DIRCT">Direct</option>
											<option value="GRBUN">Bunnings</option>
                                            <option value="OTHER">Other</option>
                                        </select>
                                      </div>
                                      <div class="form-group">
                                        <label for="contain">Within distance (km)</label>
                                        <input class="form-control" type="text" name="distance" id="distance" value="20" />
                                      </div>
                                      <div class="form-group">
                                        <label for="filter_rating">Filter rating</label>
                                        <select class="form-control" name="filter_rating" id="filter_rating">
                                            <option value="" selected>All</option>
                                            <option value="half">Half or above</option>
                                            <option value="1">1 or above</option>
                                            <option value="2">2 or above</option>
                                            <option value="3">3 or above</option>
                                            <option value="4">4 or above</option>
                                            <option value="5">5</option>
                                        </select>
                                      </div>
                                      <div class="form-check">
                                        <input type="checkbox" class="form-check-input" name="filter_new" id="filter_new" value="yes">
                                        <label class="form-check-label" for="filter_new">Show only "new"</label>
                                      </div>
                                      <button type="button" class="btn btn-primary search-button"><span class="fas fa-search" aria-hidden="true"></span></button>
                                    </form>
                                </div>
                            </div>
                            <button type="button" class="btn btn-primary search-button" id="search-button"><span class="fas fa-search" aria-hidden="true"></span></button>
                        </div>
                    </div>
                </div>
              </div>
            </div>
    	</div>
    </div>    


    <div class="container">
    
      <p id="result-summary" style="display: none;">Results for customers within <strong id="distance-result"></strong> of <strong id="location-result"></strong> </p>
      
      <div id="customer-map"></div>
      
    </div>
        
    <div class="container" id="results-div" style="display: none;">
      
      <table class="table table-striped table-bordered" id="customer-results" cellspacing="0" width="100%">
        <thead>
          <tr>   
            <th>Code</th>
            <th scope="col">Name</th>
            <th scope="col">Branch</th>
			<th scope="col">Cust Cat.</th>
            <th scope="col">Distance</th>
            <th scope="col">Last Visit</th>
            <th>&nbsp;</th>
          </tr>
        </thead>
        <tbody>      
  
  
        </tbody>
      </table>
      
    </div> 

    
    <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCtfio_PiDqJX7V6_2cYWBz3zX63Aw_6rs&libraries=places&callback=initAutocomplete">
    </script>                
  </body>
</html>    